unit uBizAlbaranProveedorServer;

interface

uses
  schFacturasClienteServer_Intf, uDAInterfaces,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_ALBARAN_PROVEEDOR = 'Server.AlbaranProveedor';
  REF_ALBARANES_PROVEEDOR = 'REF_ALBARANES_PROVEEDOR';
  REF_ALBARANES_DEV_PROVEEDOR = 'REF_ALBARANES_DEV_PROVEEDOR';

type
  TBizAlbaranProveedorServer = class(TFacturasClienteBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  Dialogs, SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schAlbaranesProveedorClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizFacturasClienteServer }

procedure TBizAlbaranProveedorServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;
  CodigoReferencia: String;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_AlbaranesProveedorREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_AlbaranesProveedorREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_AlbaranesProveedorID_EMPRESA];
          if aChange.NewValueByName[fld_AlbaranesProveedorIMPORTE_TOTAL] < 0 then
             CodigoReferencia := REF_ALBARANES_DEV_PROVEEDOR
          else
             CodigoReferencia := REF_ALBARANES_PROVEEDOR;

          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'ID_EMPRESA'], [CodigoReferencia, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + CodigoReferencia + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName(fld_DarReferenciaVALOR).AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'ID_EMPRESA'], [CodigoReferencia, DarReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_ALBARAN_PROVEEDOR, TBizAlbaranProveedorServer);

end.
